/*
 * CRLF -> LF converter, version 0.1.
 *
 * Can be called in two forms:
 *  a) dos2unix file1 file2 (where file1 and file2 can be the same file)
 *  b) if called without any args, acts as a filter.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>

#define	BUF_LEN	65536

void do_stream_conversion(FILE *in, FILE *out)
{
	for(;;)
	{
		int ch = fgetc(in);
		if(ch == EOF)
			break;
		if(ch == 0x0D)
		{
			ch = fgetc(in);
			if(ch != 0x0A) /* MAC format, only 0x0Ds */
			{
				fputc(0x0A, out);
				if(ch == EOF)
					break;
			}
		}
		fputc(ch, out);
	}
}

int do_file_conversion(char *self, char *infilename, char *outfilename)
{
	int retval;
	static char tmpname[BUF_LEN], cmd[BUF_LEN << 2];
	srandom(getpid());
	snprintf(tmpname, BUF_LEN, "/tmp/%s2%s-%lu", infilename, outfilename, random());
	snprintf(cmd, BUF_LEN << 2, "cat '%s' | '%s' > '%s'; cat '%s' > '%s'",
		infilename, self, tmpname, tmpname, outfilename);
	retval = system(cmd);
	unlink(tmpname);
	return retval;
}

int main(int argc, char *argv[])
{
	if(argc == 3)
		return do_file_conversion(argv[0], argv[1], argv[2]);
	if(argc == 1)
	{
		do_stream_conversion(stdin, stdout);
		return 0;
	}
	printf("Usage: %s [<infile> <outfile>]\n", argv[0]);
	return -1;
}
